//+------------------------------------------------------------------+
//|                                                  my_grid_001.mq4 |
//|                        Copyright 2015, MetaQuotes Software Corp. |
//|                                             https://www.mql5.com |
//+------------------------------------------------------------------+
#property copyright "Copyright 2015, MetaQuotes Software Corp."
#property link      "https://www.mql5.com"
#property version   "1.00"
#property strict

extern int Step = 50;

extern int plus_vniz = 300;
extern int vpravo = 300;
double upprice, dnprice, tick, uporder;
int okruglenie;
//+------------------------------------------------------------------+
//| Expert initialization function                                   |
//+------------------------------------------------------------------+
int OnInit()
  {
//---
   okruglenie = Digits-1;
   if(Digits == 3 || Digits == 5)
   {
     okruglenie  = Digits-2;
   }   
//---
   return(INIT_SUCCEEDED);
  }
//+------------------------------------------------------------------+
//| Expert deinitialization function                                 |
//+------------------------------------------------------------------+
void OnDeinit(const int reason)
  {
//---
   
  }
//+------------------------------------------------------------------+
//| Expert tick function                                             |
//+------------------------------------------------------------------+
void OnTick()
  {
//---
    tick = Bid;
//+---------------
    upprice = NormalizeDouble(tick,okruglenie);
     if(upprice < Bid+(0.5*Step*Point)) {upprice = NormalizeDouble(tick,okruglenie)+Step*Point;}
     if(upprice < Bid+(0.5*Step*Point)) {upprice = NormalizeDouble(tick,okruglenie)+Step*2*Point;} //      

    dnprice = NormalizeDouble(tick,okruglenie);
     if(dnprice > Bid-(0.5*Step*Point)) {dnprice = NormalizeDouble(tick,okruglenie)-Step*Point;}
     if(dnprice > Bid-(0.5*Step*Point)) {upprice = NormalizeDouble(tick,okruglenie)-Step*2*Point;} //      
   // ,   ,  ,      ?
   if(upprice < dnprice) return;
   
   drawline("LineUP", DeepSkyBlue, upprice);
   drawline("LineDN", Red, dnprice);
   drawObject(upprice, 120, DoubleToStr(1,0), Blue);
   drawObject(dnprice, 140, DoubleToStr(2,0), Red);
//+---------------
   uporder = FindOrder(upprice); //     upprice
   if(uporder > 1) //   ,    
   {
    drawObject(upprice, 160, DoubleToStr(3,0), Yellow);
    return;
   }
   else if(uporder < 1) // ,   ,  
        {
         drawObject(0, 160, DoubleToStr(3,0), Red);
         SetNewStopOrder(OP_BUYSTOP, upprice);
         return;
        }
  }
//+------------------------------------------------------------------+
double FindOrder(double oprice)
{
 int variable = 0;
 for(int cnt = OrdersTotal()-1; cnt>=0; cnt--)
 {
  if(OrderSelect(cnt,SELECT_BY_POS, MODE_TRADES))
  {
   if(OrderSymbol() == Symbol())
   {
    //if(OrderMagicNumber() == Magic)
    if(OrderType() == OP_BUY || OrderType() == OP_BUYSTOP)
    {
     if(OrderOpenPrice() == oprice)
     {
        ++variable;
     }
    }
   }
  }
 }
  return(variable);
}
//+------------------------------------------------------------------+
//    
double drawObject(double txt, int vniz, string objname, color clr)
{
   string txt1 = DoubleToStr(txt,Digits);
   ObjectCreate("1455"+objname, OBJ_LABEL,0,0,1.0);
   ObjectSetText("1455"+objname,txt1,10, "Arial Black", clr);
   ObjectSet("1455"+objname, OBJPROP_CORNER, 1);
   ObjectSet("1455"+objname, OBJPROP_XDISTANCE, vpravo);
   ObjectSet("1455"+objname, OBJPROP_YDISTANCE, vniz+plus_vniz);
   return(0);
}
//+------------------------------------------------------------------+
//     
int drawline(string NameL, color col, double Y1)
{
   ObjectDelete(NameL); //   ,    
   
   ObjectCreate(NameL, OBJ_HLINE, 0,0,Y1,0,0);
   ObjectSet   (NameL, OBJPROP_COLOR, col);
   ObjectSet   (NameL, OBJPROP_STYLE, STYLE_DASHDOTDOT);
   ObjectSet   (NameL, OBJPROP_WIDTH, 1);
   ObjectSet   (NameL, OBJPROP_BACK,  false);
   ObjectSet   (NameL, OBJPROP_RAY,   false);
   return(0);
}
//+------------------------------------------------------------------+
void SetNewStopOrder(int pos, double opprice)
{
  int ticket = OrderSend(Symbol(),pos,0.01,NormalizeDouble(opprice,Digits),10,0,0,NULL,0,0,Blue);
   if(ticket<0) 
     { 
      Print("OrderSend    #",GetLastError());
      drawObject(GetLastError(), 180, DoubleToStr(4,0), Blue);
      return; 
     } 
   else if(ticket>=0)
     {
      uporder = 1;
      Print(" OrderSend  ");
      drawObject(0, 200, DoubleToStr(5,0), Blue);
      return;
     }

  return;
}